
// @ϊs
float4x4 WorldViewProjMatrix      : WORLDVIEWPROJECTION;
float4x4 WorldViewMatrix      : WORLDVIEW;
float4x4 ViewMatrix      : VIEW;
float4x4 WorldMatrix              : WORLD;
float4x4 LightWorldViewProjMatrix : WORLDVIEWPROJECTION < string Object = "Light"; >;
float3   CameraPosition    : POSITION  < string Object = "Camera"; >;

float    SpecularPower : SPECULARPOWER < string Object = "Geometry"; >;

// MMD{sampler㏑Ȃ߂̋LqłB폜sB
sampler MMDSamp0 : register(s0);
sampler MMDSamp1 : register(s1);
sampler MMDSamp2 : register(s2);


// IuWFNg̃eNX`
texture ObjectTexture: MATERIALTEXTURE;
sampler ObjTexSampler = sampler_state {
    texture = <ObjectTexture>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
};

float4   MaterialDiffuse   : DIFFUSE  < string Object = "Geometry"; >;



///////////////////////////////////////////////////////////////////////////////////////////////
// IuWFNg`iZtVhEOFFj

struct VS_OUTPUT
{
    float4 Pos        : POSITION;    // ˉeϊW
    float4  PPos 	: TEXCOORD0;    // Zl
    float2  Tex		  : TEXCOORD1;	//eNX`W
};

// _VF[_
VS_OUTPUT Basic_VS(float4 Pos : POSITION, float3 Normal : NORMAL, float2 Tex : TEXCOORD0)
{
    VS_OUTPUT Out = (VS_OUTPUT)0;


	Out.Pos = mul( Pos, WorldViewProjMatrix);

	Out.PPos= mul( Pos, WorldViewMatrix);
	Out.Tex = Tex;
    return Out;
}

// sNZVF[_
float4 Basic_PS( VS_OUTPUT IN, float VFace : VFACE): COLOR0
{
		
       float a = tex2D(ObjTexSampler,IN.Tex).a;
       a = pow(a, 2.2);
       a *= MaterialDiffuse.a;

       clip(a-0.1);

	   float Z = IN.PPos.z;// / IN.PPos.w;


       return float4(Z,0.0,0.0,1.0);
}

// IuWFNg`peNjbN
technique MainTec < string MMDPass = "object"; > {
    pass DrawObject
    {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
        VertexShader = compile vs_3_0 Basic_VS();
        PixelShader  = compile ps_3_0 Basic_PS();
    }
}

// IuWFNg`peNjbN
technique MainTecBS  < string MMDPass = "object_ss"; > {
    pass DrawObject {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
        VertexShader = compile vs_3_0 Basic_VS();
        PixelShader  = compile ps_3_0 Basic_PS();
    }
}
technique EdgeTec < string MMDPass = "edge"; > {

}
technique ShadowTech < string MMDPass = "shadow";  > {
    
}
technique ZplotTec < string MMDPass = "zplot"; > {
    
}
///////////////////////////////////////////////////////////////////////////////////////////////